.test:
  image: node:lts-alpine
  timeout: "5m"
  script:
  - yarn install --non-interactive --pure-lockfile
  - yarn run nyc yarn test --reporter mocha-multi
  coverage: /All files[^|]*\|[^|]*\s+([\d\.]+)/
  variables:
    # use the mocha-multi reporter to create test reports for GitLab CI
    multi: "spec=- xunit=junit.xml"
  artifacts:
    reports:
      junit: junit.xml

deploy:
  variables:
    HOST: mars.emergencyx.de
  before_script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo "$SSH_KNOWN_HOSTS" > ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
  script:
    - ssh ${SSH_USER}@${HOST} "cd ${DEPLOYMENT} && forever stop index.js"
    - ssh ${SSH_USER}@${HOST} "cd ${DEPLOYMENT} && git pull"
    - ssh ${SSH_USER}@${HOST} "cd ${DEPLOYMENT} && yarn install --production --pure-lockfile"
    - ssh ${SSH_USER}@${HOST} "cd ${DEPLOYMENT} && forever start index.js"
  environment:
    name: production
    url: https://${HOST}
  only:
    - master
  when: manual
